Index: src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php
IDEA additional info:
Subsystem: com.intellij.openapi.diff.impl.patch.CharsetEP
<+>UTF-8
===================================================================
--- src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision 54b5657ad2e80eb6f9bf910415d8a992a8b6d777)
+++ src/includes/classes/Smarty/sysplugins/smarty_internal_templateparser.php	(revision )
@@ -3698,729 +1834,867 @@
             $this->_retvalue = SMARTY_INTERNAL_COMPILE_BLOCK::compileParentBlock($this->compiler);
         }
     }
-    #line 2487 "smarty_internal_templateparser.php"
-    #line 468 "smarty_internal_templateparser.y"
+
+    #line 550 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r54()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + 0]->minor . 'close', array());
+        $tag =
+            trim(substr($this->yystack[ $this->yyidx + 0 ]->minor, $this->lex->ldel_length, - $this->lex->rdel_length),
+                 ' /');
+        if ($tag == 'strip') {
+            $this->strip = false;
+            $this->_retvalue = null;
+        } else {
+            $this->_retvalue = $this->compiler->compileTag($tag . 'close', array());
-    }
+        }
-    #line 2492 "smarty_internal_templateparser.php"
-    #line 472 "smarty_internal_templateparser.y"
+    }
+
+    #line 559 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r55()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + - 1]->minor . 'close', array(), array('modifier_list' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + 0 ]->minor . 'close', array());
     }
-    #line 2497 "smarty_internal_templateparser.php"
-    #line 477 "smarty_internal_templateparser.y"
+
+    #line 563 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r56()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + - 2]->minor . 'close', array(), array('object_method' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + - 1 ]->minor . 'close', array(),
+                                                       array('modifier_list' => $this->yystack[ $this->yyidx +
+                                                       0 ]->minor));
     }
-    #line 2502 "smarty_internal_templateparser.php"
-    #line 481 "smarty_internal_templateparser.y"
+
+    #line 568 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r57()
     {
-        $this->_retvalue = $this->compiler->compileTag($this->yystack[$this->yyidx + - 3]->minor . 'close', array(), array('object_method' => $this->yystack[$this->yyidx + - 1]->minor, 'modifier_list' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + - 2 ]->minor . 'close', array(),
+                                                       array('object_method' => $this->yystack[ $this->yyidx +
+                                                       0 ]->minor));
     }
-    #line 2507 "smarty_internal_templateparser.php"
-    #line 489 "smarty_internal_templateparser.y"
+
+    #line 572 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r58()
     {
+        $this->_retvalue = $this->compiler->compileTag($this->yystack[ $this->yyidx + - 3 ]->minor . 'close', array(),
+                                                       array('object_method'         => $this->yystack[ $this->yyidx +
+                                                       - 1 ]->minor, 'modifier_list' => $this->yystack[ $this->yyidx +
+                                                       0 ]->minor));
+    }
+
+    #line 580 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r59()
+    {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor;
-        $this->_retvalue[] = $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue[] = $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2513 "smarty_internal_templateparser.php"
-    #line 495 "smarty_internal_templateparser.y"
-    function yy_r59()
+
+    #line 586 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r60()
     {
-        $this->_retvalue = array($this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = array($this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2518 "smarty_internal_templateparser.php"
-    #line 500 "smarty_internal_templateparser.y"
-    function yy_r60()
+
+    #line 591 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r61()
     {
         $this->_retvalue = array();
     }
-    #line 2523 "smarty_internal_templateparser.php"
-    #line 505 "smarty_internal_templateparser.y"
-    function yy_r61()
+
+    #line 596 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r62()
     {
-        if (preg_match('~^true$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = array($this->yystack[$this->yyidx + - 2]->minor => 'true');
-        } elseif (preg_match('~^false$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = array($this->yystack[$this->yyidx + - 2]->minor => 'false');
-        } elseif (preg_match('~^null$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = array($this->yystack[$this->yyidx + - 2]->minor => 'null');
+        if (defined($this->yystack[ $this->yyidx + 0 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + 0 ]->minor, $this->compiler);
+            }
+            $this->_retvalue =
+                array($this->yystack[ $this->yyidx + - 2 ]->minor => $this->yystack[ $this->yyidx + 0 ]->minor);
         } else {
-            $this->_retvalue = array($this->yystack[$this->yyidx + - 2]->minor => "'" . $this->yystack[$this->yyidx + 0]->minor . "'");
+            $this->_retvalue =
+                array($this->yystack[ $this->yyidx + - 2 ]->minor => '\'' . $this->yystack[ $this->yyidx + 0 ]->minor .
+                    '\'');
         }
     }
-    #line 2536 "smarty_internal_templateparser.php"
-    #line 517 "smarty_internal_templateparser.y"
-    function yy_r62()
+
+    #line 607 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r63()
     {
-        $this->_retvalue = array(trim($this->yystack[$this->yyidx + - 1]->minor, " =\n\r\t") => $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue =
+            array(trim($this->yystack[ $this->yyidx + - 1 ]->minor, " =\n\r\t") => $this->yystack[ $this->yyidx +
+            0 ]->minor);
     }
-    #line 2541 "smarty_internal_templateparser.php"
-    #line 525 "smarty_internal_templateparser.y"
-    function yy_r64()
+
+    #line 615 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r65()
     {
-        $this->_retvalue = "'" . $this->yystack[$this->yyidx + 0]->minor . "'";
+        $this->_retvalue = '\'' . $this->yystack[ $this->yyidx + 0 ]->minor . '\'';
     }
-    #line 2546 "smarty_internal_templateparser.php"
-    #line 537 "smarty_internal_templateparser.y"
-    function yy_r67()
+
+    #line 627 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r68()
     {
-        $this->_retvalue = array($this->yystack[$this->yyidx + - 2]->minor => $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue =
+            array($this->yystack[ $this->yyidx + - 2 ]->minor => $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2551 "smarty_internal_templateparser.php"
-    #line 550 "smarty_internal_templateparser.y"
-    function yy_r69()
+
+    #line 640 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r70()
     {
-        $this->yystack[$this->yyidx + - 2]->minor[] = $this->yystack[$this->yyidx + 0]->minor;
+        $this->yystack[ $this->yyidx + - 2 ]->minor[] = $this->yystack[ $this->yyidx + 0 ]->minor;
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 2 ]->minor;
     }
-    #line 2557 "smarty_internal_templateparser.php"
-    #line 555 "smarty_internal_templateparser.y"
-    function yy_r70()
+
+    #line 645 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r71()
     {
-        $this->_retvalue = array('var' => $this->yystack[$this->yyidx + - 2]->minor, 'value' => $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = array('var'   => '\'' . substr($this->yystack[ $this->yyidx + - 2 ]->minor, 1) . '\'',
+                                 'value' => $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2562 "smarty_internal_templateparser.php"
-    #line 583 "smarty_internal_templateparser.y"
-    function yy_r75()
+
+    #line 652 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r73()
     {
-        $this->_retvalue = '$_smarty_tpl->getStreamVariable(\'' . $this->yystack[$this->yyidx + - 2]->minor . '://' . $this->yystack[$this->yyidx + 0]->minor . '\')';
+        $this->_retvalue = array('var'   => $this->yystack[ $this->yyidx + - 2 ]->minor,
+                                 'value' => $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2567 "smarty_internal_templateparser.php"
-    #line 588 "smarty_internal_templateparser.y"
-    function yy_r76()
+
+    #line 676 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r77()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . trim($this->yystack[$this->yyidx + - 1]->minor) . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue =
+            '$_smarty_tpl->getStreamVariable(\'' . substr($this->yystack[ $this->yyidx + - 2 ]->minor, 1) . '://' .
+            $this->yystack[ $this->yyidx + 0 ]->minor . '\')';
     }
-    #line 2572 "smarty_internal_templateparser.php"
-    #line 607 "smarty_internal_templateparser.y"
-    function yy_r80()
+
+    #line 681 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r78()
     {
-        $this->_retvalue = $this->compiler->compileTag('private_modifier', array(), array('value' => $this->yystack[$this->yyidx + - 1]->minor, 'modifierlist' => $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 2 ]->minor . trim($this->yystack[ $this->yyidx + - 1 ]->minor) .
+            $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2577 "smarty_internal_templateparser.php"
-    #line 613 "smarty_internal_templateparser.y"
+
+    #line 695 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r81()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->compiler->compileTag('private_modifier', array(),
+                                                       array('value' => $this->yystack[ $this->yyidx + - 1 ]->minor,
+                                                             'modifierlist' => $this->yystack[ $this->yyidx +
+                                                             0 ]->minor));
     }
-    #line 2582 "smarty_internal_templateparser.php"
-    #line 617 "smarty_internal_templateparser.y"
+
+    #line 701 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r82()
     {
-        $this->_retvalue = 'in_array(' . $this->yystack[$this->yyidx + - 2]->minor . ',' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue = (isset($this->yystack[ $this->yyidx + - 1 ]->minor[ 'pre' ]) ?
+                $this->yystack[ $this->yyidx + - 1 ]->minor[ 'pre' ] : '') .
+            $this->yystack[ $this->yyidx + - 2 ]->minor . $this->yystack[ $this->yyidx + - 1 ]->minor[ 'op' ] .
+            $this->yystack[ $this->yyidx + 0 ]->minor .
+            (isset($this->yystack[ $this->yyidx + - 1 ]->minor[ 'pre' ]) ? ')' : '');
     }
-    #line 2587 "smarty_internal_templateparser.php"
-    #line 621 "smarty_internal_templateparser.y"
+
+    #line 704 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r83()
     {
-        $this->_retvalue = 'in_array(' . $this->yystack[$this->yyidx + - 2]->minor . ',(array)' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + 0 ]->minor . $this->yystack[ $this->yyidx + - 1 ]->minor . ')';
     }
-    #line 2592 "smarty_internal_templateparser.php"
-    #line 629 "smarty_internal_templateparser.y"
+
+    #line 708 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r84()
+    {
+        $this->_retvalue = 'in_array(' . $this->yystack[ $this->yyidx + - 2 ]->minor . ',' .
+            $this->yystack[ $this->yyidx + 0 ]->minor . ')';
+    }
+
+    #line 712 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r85()
     {
-        $this->_retvalue = '!(' . $this->yystack[$this->yyidx + - 2]->minor . ' % ' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue = 'in_array(' . $this->yystack[ $this->yyidx + - 2 ]->minor . ',(array)' .
+            $this->yystack[ $this->yyidx + 0 ]->minor . ')';
     }
-    #line 2597 "smarty_internal_templateparser.php"
-    #line 633 "smarty_internal_templateparser.y"
+
+    #line 716 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r86()
     {
-        $this->_retvalue = '(' . $this->yystack[$this->yyidx + - 2]->minor . ' % ' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 2 ]->minor . $this->yystack[ $this->yyidx + - 1 ]->minor .
+            $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2602 "smarty_internal_templateparser.php"
-    #line 637 "smarty_internal_templateparser.y"
-    function yy_r87()
-    {
-        $this->_retvalue = '!(1 & ' . $this->yystack[$this->yyidx + - 1]->minor . ')';
-    }
-    #line 2607 "smarty_internal_templateparser.php"
-    #line 641 "smarty_internal_templateparser.y"
+
+    #line 728 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r88()
     {
-        $this->_retvalue = '(1 & ' . $this->yystack[$this->yyidx + - 1]->minor . ')';
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 5 ]->minor . ' ? ' .
+            $this->compiler->compileVariable('\'' . substr($this->yystack[ $this->yyidx + - 2 ]->minor, 1) . '\'') .
+            ' : ' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2612 "smarty_internal_templateparser.php"
-    #line 645 "smarty_internal_templateparser.y"
+
+    #line 732 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r89()
     {
-        $this->_retvalue = '!(1 & ' . $this->yystack[$this->yyidx + - 2]->minor . ' / ' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 5 ]->minor . ' ? ' . $this->yystack[ $this->yyidx + - 2 ]->minor . ' : ' .
+            $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2617 "smarty_internal_templateparser.php"
-    #line 649 "smarty_internal_templateparser.y"
-    function yy_r90()
+
+    #line 747 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r92()
     {
-        $this->_retvalue = '(1 & ' . $this->yystack[$this->yyidx + - 2]->minor . ' / ' . $this->yystack[$this->yyidx + 0]->minor . ')';
+        $this->_retvalue = '!' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2622 "smarty_internal_templateparser.php"
-    #line 673 "smarty_internal_templateparser.y"
-    function yy_r96()
-    {
-        self::$prefix_number ++;
-        $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . '=' . $this->yystack[$this->yyidx + 0]->minor . ';?>';
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . $this->yystack[$this->yyidx + - 1]->minor . '$_tmp' . self::$prefix_number;
-    }
-    #line 2629 "smarty_internal_templateparser.php"
-    #line 682 "smarty_internal_templateparser.y"
+
+    #line 768 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r97()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 6]->minor . ' ? ' . $this->compileVariable("'" . $this->yystack[$this->yyidx + - 2]->minor . "'") . ' : ' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 2 ]->minor . '.' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2634 "smarty_internal_templateparser.php"
-    #line 686 "smarty_internal_templateparser.y"
+
+    #line 772 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r98()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 5]->minor . ' ? ' . $this->yystack[$this->yyidx + - 2]->minor . ' : ' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor . '.';
     }
-    #line 2639 "smarty_internal_templateparser.php"
-    #line 701 "smarty_internal_templateparser.y"
-    function yy_r101()
+
+    #line 776 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r99()
     {
-        $this->_retvalue = '!' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = '.' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2644 "smarty_internal_templateparser.php"
-    #line 722 "smarty_internal_templateparser.y"
-    function yy_r106()
+
+    #line 781 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r100()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . '.' . $this->yystack[$this->yyidx + 0]->minor;
+        if (defined($this->yystack[ $this->yyidx + 0 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + 0 ]->minor, $this->compiler);
-    }
+            }
-    #line 2649 "smarty_internal_templateparser.php"
-    #line 726 "smarty_internal_templateparser.y"
-    function yy_r107()
-    {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor . '.';
+            $this->_retvalue = $this->yystack[ $this->yyidx + 0 ]->minor;
+        } else {
+            $this->_retvalue = '\'' . $this->yystack[ $this->yyidx + 0 ]->minor . '\'';
-    }
+        }
-    #line 2654 "smarty_internal_templateparser.php"
-    #line 730 "smarty_internal_templateparser.y"
-    function yy_r108()
+    }
+
+    #line 798 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r102()
     {
-        $this->_retvalue = '.' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = "(" . $this->yystack[ $this->yyidx + - 1 ]->minor . ")";
     }
-    #line 2659 "smarty_internal_templateparser.php"
-    #line 735 "smarty_internal_templateparser.y"
-    function yy_r109()
+
+    #line 813 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r105()
     {
-        if (preg_match('~^true$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = 'true';
-        } elseif (preg_match('~^false$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = 'false';
-        } elseif (preg_match('~^null$~i', $this->yystack[$this->yyidx + 0]->minor)) {
-            $this->_retvalue = 'null';
+        self::$prefix_number ++;
+        if ($this->yystack[ $this->yyidx + - 2 ]->minor[ 'var' ] == '\'smarty\'') {
+            $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . ' = ' .
+                $this->compiler->compileTag('private_special_variable', array(),
+                                            $this->yystack[ $this->yyidx + - 2 ]->minor[ 'smarty_internal_index' ]) .
+                ';?>';
         } else {
-            $this->_retvalue = "'" . $this->yystack[$this->yyidx + 0]->minor . "'";
+            $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . ' = ' .
+                $this->compiler->compileVariable($this->yystack[ $this->yyidx + - 2 ]->minor[ 'var' ]) .
+                $this->yystack[ $this->yyidx + - 2 ]->minor[ 'smarty_internal_index' ] . ';?>';
         }
+        $this->_retvalue = '$_tmp' . self::$prefix_number . '::' . $this->yystack[ $this->yyidx + 0 ]->minor[ 0 ] .
+            $this->yystack[ $this->yyidx + 0 ]->minor[ 1 ];
     }
-    #line 2672 "smarty_internal_templateparser.php"
-    #line 753 "smarty_internal_templateparser.y"
-    function yy_r111()
+
+    #line 824 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r106()
     {
-        $this->_retvalue = "(" . $this->yystack[$this->yyidx + - 1]->minor . ")";
+        self::$prefix_number ++;
+        $tmp = $this->compiler->appendCode('<?php ob_start();?>', $this->yystack[ $this->yyidx + 0 ]->minor);
+        $this->compiler->prefix_code[] =
+            $this->compiler->appendCode($tmp, '<?php $_tmp' . self::$prefix_number . '=ob_get_clean();?>');
+        $this->_retvalue = '$_tmp' . self::$prefix_number;
     }
-    #line 2677 "smarty_internal_templateparser.php"
-    #line 768 "smarty_internal_templateparser.y"
-    function yy_r114()
+
+    #line 841 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r109()
     {
-        if (!$this->security || isset($this->smarty->registered_classes[$this->yystack[$this->yyidx + - 2]->minor]) || $this->smarty->security_policy->isTrustedStaticClass($this->yystack[$this->yyidx + - 2]->minor, $this->compiler)) {
+        if (!in_array(strtolower($this->yystack[ $this->yyidx + - 2 ]->minor), array('self', 'parent')) &&
+            (!$this->security ||
+                $this->security->isTrustedStaticClassAccess($this->yystack[ $this->yyidx + - 2 ]->minor,
+                                                            $this->yystack[ $this->yyidx + 0 ]->minor, $this->compiler))
+        ) {
-            if (isset($this->smarty->registered_classes[$this->yystack[$this->yyidx + - 2]->minor])) {
+            if (isset($this->smarty->registered_classes[ $this->yystack[ $this->yyidx + - 2 ]->minor ])) {
-                $this->_retvalue = $this->smarty->registered_classes[$this->yystack[$this->yyidx + - 2]->minor] . '::' . $this->yystack[$this->yyidx + 0]->minor;
+                $this->_retvalue =
+                    $this->smarty->registered_classes[ $this->yystack[ $this->yyidx + - 2 ]->minor ] . '::' .
+                    $this->yystack[ $this->yyidx + 0 ]->minor[ 0 ] . $this->yystack[ $this->yyidx + 0 ]->minor[ 1 ];
             } else {
-                $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . '::' . $this->yystack[$this->yyidx + 0]->minor;
+                $this->_retvalue = $this->yystack[ $this->yyidx + - 2 ]->minor . '::' .
+                    $this->yystack[ $this->yyidx + 0 ]->minor[ 0 ] . $this->yystack[ $this->yyidx + 0 ]->minor[ 1 ];
             }
         } else {
-            $this->compiler->trigger_template_error("static class '" . $this->yystack[$this->yyidx + - 2]->minor . "' is undefined or not allowed by security setting");
+            $this->compiler->trigger_template_error("static class '" . $this->yystack[ $this->yyidx + - 2 ]->minor .
+                                                    "' is undefined or not allowed by security setting");
         }
     }
-    #line 2690 "smarty_internal_templateparser.php"
-    #line 780 "smarty_internal_templateparser.y"
-    function yy_r115()
+
+    #line 860 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r111()
     {
-        if ($this->yystack[$this->yyidx + - 2]->minor['var'] == '\'smarty\'') {
-            $this->_retvalue = $this->compiler->compileTag('private_special_variable', array(), $this->yystack[$this->yyidx + - 2]->minor['smarty_internal_index']) . '::' . $this->yystack[$this->yyidx + 0]->minor;
-        } else {
-            $this->_retvalue = $this->compileVariable($this->yystack[$this->yyidx + - 2]->minor['var']) . $this->yystack[$this->yyidx + - 2]->minor['smarty_internal_index'] . '::' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + 0 ]->minor;
-        }
+    }
-    }
-    #line 2699 "smarty_internal_templateparser.php"
-    #line 789 "smarty_internal_templateparser.y"
-    function yy_r116()
+
+    #line 871 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r112()
     {
-        self::$prefix_number ++;
-        $this->compiler->prefix_code[] = '<?php ob_start();?>' . $this->yystack[$this->yyidx + - 1]->minor . '<?php $_tmp' . self::$prefix_number . '=ob_get_clean();?>';
-        $this->_retvalue = '$_tmp' . self::$prefix_number;
+        $this->_retvalue =
+            $this->compiler->compileVariable('\'' . substr($this->yystack[ $this->yyidx + 0 ]->minor, 1) . '\'');
     }
-    #line 2706 "smarty_internal_templateparser.php"
-    #line 804 "smarty_internal_templateparser.y"
-    function yy_r118()
+
+    #line 874 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r113()
     {
-        if ($this->yystack[$this->yyidx + 0]->minor['var'] == '\'smarty\'') {
+        if ($this->yystack[ $this->yyidx + 0 ]->minor[ 'var' ] == '\'smarty\'') {
-            $smarty_var = $this->compiler->compileTag('private_special_variable', array(), $this->yystack[$this->yyidx + 0]->minor['smarty_internal_index']);
+            $smarty_var = $this->compiler->compileTag('private_special_variable', array(),
+                                                      $this->yystack[ $this->yyidx +
+                                                      0 ]->minor[ 'smarty_internal_index' ]);
             $this->_retvalue = $smarty_var;
         } else {
-            // used for array reset,next,prev,end,current 
+            // used for array reset,next,prev,end,current
-            $this->last_variable = $this->yystack[$this->yyidx + 0]->minor['var'];
+            $this->last_variable = $this->yystack[ $this->yyidx + 0 ]->minor[ 'var' ];
-            $this->last_index = $this->yystack[$this->yyidx + 0]->minor['smarty_internal_index'];
+            $this->last_index = $this->yystack[ $this->yyidx + 0 ]->minor[ 'smarty_internal_index' ];
-            $this->_retvalue = $this->compileVariable($this->yystack[$this->yyidx + 0]->minor['var']) . $this->yystack[$this->yyidx + 0]->minor['smarty_internal_index'];
+            $this->_retvalue = $this->compiler->compileVariable($this->yystack[ $this->yyidx + 0 ]->minor[ 'var' ]) .
+                $this->yystack[ $this->yyidx + 0 ]->minor[ 'smarty_internal_index' ];
         }
     }
-    #line 2719 "smarty_internal_templateparser.php"
-    #line 817 "smarty_internal_templateparser.y"
+
+    #line 887 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r114()
+    {
+        $this->_retvalue = '$_smarty_tpl->tpl_vars[' . $this->yystack[ $this->yyidx + - 2 ]->minor . ']->' .
+            $this->yystack[ $this->yyidx + 0 ]->minor;
+    }
+
+    #line 897 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r116()
+    {
+        $this->_retvalue =
+            $this->compiler->compileConfigVariable("'" . $this->yystack[ $this->yyidx + - 1 ]->minor . "'");
+    }
+
+    #line 901 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r117()
+    {
+        $this->_retvalue = '(is_array($tmp = ' .
+            $this->compiler->compileConfigVariable("'" . $this->yystack[ $this->yyidx + - 2 ]->minor . "'") .
+            ') ? $tmp' . $this->yystack[ $this->yyidx + 0 ]->minor . ' :null)';
+    }
+
+    #line 905 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r118()
+    {
+        $this->_retvalue = $this->compiler->compileConfigVariable($this->yystack[ $this->yyidx + - 1 ]->minor);
+    }
+
+    #line 909 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r119()
     {
-        $this->_retvalue = '$_smarty_tpl->tpl_vars[' . $this->yystack[$this->yyidx + - 2]->minor . ']->' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue =
+            '(is_array($tmp = ' . $this->compiler->compileConfigVariable($this->yystack[ $this->yyidx + - 2 ]->minor) .
+            ') ? $tmp' . $this->yystack[ $this->yyidx + 0 ]->minor . ' : null)';
     }
-    #line 2724 "smarty_internal_templateparser.php"
-    #line 827 "smarty_internal_templateparser.y"
-    function yy_r121()
+
+    #line 913 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r120()
     {
-        $this->_retvalue = '$_smarty_tpl->getConfigVariable(\'' . $this->yystack[$this->yyidx + - 1]->minor . '\')';
+        $this->_retvalue = array('var' => '\'' . substr($this->yystack[ $this->yyidx + - 1 ]->minor, 1) . '\'',
+                                 'smarty_internal_index' => $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2729 "smarty_internal_templateparser.php"
-    #line 831 "smarty_internal_templateparser.y"
-    function yy_r122()
+
+    #line 916 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r121()
     {
-        $this->_retvalue = '(is_array($tmp = $_smarty_tpl->getConfigVariable(\'' . $this->yystack[$this->yyidx + - 2]->minor . '\')) ? $tmp' . $this->yystack[$this->yyidx + 0]->minor . ' :null)';
+        $this->_retvalue = array('var'                   => $this->yystack[ $this->yyidx + - 1 ]->minor,
+                                 'smarty_internal_index' => $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2734 "smarty_internal_templateparser.php"
-    #line 835 "smarty_internal_templateparser.y"
+
+    #line 929 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r123()
     {
-        $this->_retvalue = '$_smarty_tpl->getConfigVariable(' . $this->yystack[$this->yyidx + - 1]->minor . ')';
+        return;
     }
-    #line 2739 "smarty_internal_templateparser.php"
-    #line 839 "smarty_internal_templateparser.y"
+
+    #line 935 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r124()
     {
-        $this->_retvalue = '(is_array($tmp = $_smarty_tpl->getConfigVariable(' . $this->yystack[$this->yyidx + - 2]->minor . ')) ? $tmp' . $this->yystack[$this->yyidx + 0]->minor . ' : null)';
+        $this->_retvalue =
+            '[' . $this->compiler->compileVariable('\'' . substr($this->yystack[ $this->yyidx + 0 ]->minor, 1) . '\'') .
+            ']';
     }
-    #line 2744 "smarty_internal_templateparser.php"
-    #line 843 "smarty_internal_templateparser.y"
+
+    #line 938 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r125()
     {
-        $this->_retvalue = array('var' => $this->yystack[$this->yyidx + - 1]->minor, 'smarty_internal_index' => $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = '[' . $this->compiler->compileVariable($this->yystack[ $this->yyidx + 0 ]->minor) . ']';
     }
-    #line 2749 "smarty_internal_templateparser.php"
-    #line 856 "smarty_internal_templateparser.y"
+
+    #line 942 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r126()
+    {
+        $this->_retvalue = '[' . $this->compiler->compileVariable($this->yystack[ $this->yyidx + - 2 ]->minor) . '->' .
+            $this->yystack[ $this->yyidx + 0 ]->minor . ']';
+    }
+
+    #line 946 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r127()
     {
-        return;
+        if (defined($this->yystack[ $this->yyidx + 0 ]->minor)) {
+            if ($this->security) {
+                $this->security->isTrustedConstant($this->yystack[ $this->yyidx + 0 ]->minor, $this->compiler);
-    }
+            }
-    #line 2754 "smarty_internal_templateparser.php"
-    #line 862 "smarty_internal_templateparser.y"
+            $this->_retvalue = '[' . $this->yystack[ $this->yyidx + 0 ]->minor . ']';
+        } else {
+            $this->_retvalue = "['" . $this->yystack[ $this->yyidx + 0 ]->minor . "']";
+        }
+    }
+
+    #line 957 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r128()
     {
-        $this->_retvalue = '[' . $this->compileVariable($this->yystack[$this->yyidx + 0]->minor) . ']';
+        $this->_retvalue = '[' . $this->yystack[ $this->yyidx + 0 ]->minor . ']';
     }
-    #line 2759 "smarty_internal_templateparser.php"
-    #line 866 "smarty_internal_templateparser.y"
+
+    #line 962 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r129()
     {
-        $this->_retvalue = '[' . $this->compileVariable($this->yystack[$this->yyidx + - 2]->minor) . '->' . $this->yystack[$this->yyidx + 0]->minor . ']';
+        $this->_retvalue = '[' . $this->yystack[ $this->yyidx + - 1 ]->minor . ']';
     }
-    #line 2764 "smarty_internal_templateparser.php"
-    #line 870 "smarty_internal_templateparser.y"
+
+    #line 967 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r130()
     {
-        $this->_retvalue = "['" . $this->yystack[$this->yyidx + 0]->minor . "']";
+        $this->_retvalue = '[' . $this->compiler->compileTag('private_special_variable', array(), '[\'section\'][\'' .
+                                                                                       $this->yystack[ $this->yyidx +
+                                                                                       - 1 ]->minor .
+                                                                                       '\'][\'index\']') . ']';
     }
-    #line 2769 "smarty_internal_templateparser.php"
-    #line 874 "smarty_internal_templateparser.y"
+
+    #line 971 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r131()
     {
-        $this->_retvalue = "[" . $this->yystack[$this->yyidx + 0]->minor . "]";
+        $this->_retvalue = '[' . $this->compiler->compileTag('private_special_variable', array(), '[\'section\'][\'' .
+                                                                                       $this->yystack[ $this->yyidx +
+                                                                                       - 3 ]->minor . '\'][\'' .
+                                                                                       $this->yystack[ $this->yyidx +
+                                                                                       - 1 ]->minor . '\']') . ']';
     }
-    #line 2774 "smarty_internal_templateparser.php"
-    #line 878 "smarty_internal_templateparser.y"
+
+    #line 974 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r132()
     {
-        $this->_retvalue = "[" . $this->yystack[$this->yyidx + - 1]->minor . "]";
+        $this->_retvalue = '[' . $this->yystack[ $this->yyidx + - 1 ]->minor . ']';
     }
-    #line 2779 "smarty_internal_templateparser.php"
-    #line 883 "smarty_internal_templateparser.y"
-    function yy_r133()
-    {
-        $this->_retvalue = '[' . $this->compiler->compileTag('private_special_variable', array(), '[\'section\'][\'' . $this->yystack[$this->yyidx + - 1]->minor . '\'][\'index\']') . ']';
-    }
-    #line 2784 "smarty_internal_templateparser.php"
-    #line 887 "smarty_internal_templateparser.y"
+
+    #line 980 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r134()
     {
-        $this->_retvalue = '[' . $this->compiler->compileTag('private_special_variable', array(), '[\'section\'][\'' . $this->yystack[$this->yyidx + - 3]->minor . '\'][\'' . $this->yystack[$this->yyidx + - 1]->minor . '\']') . ']';
+        $this->_retvalue = '[' .
+            $this->compiler->compileVariable('\'' . substr($this->yystack[ $this->yyidx + - 1 ]->minor, 1) . '\'') .
+            ']';;
     }
-    #line 2789 "smarty_internal_templateparser.php"
-    #line 897 "smarty_internal_templateparser.y"
-    function yy_r136()
+
+    #line 996 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r138()
     {
         $this->_retvalue = '[]';
     }
-    #line 2794 "smarty_internal_templateparser.php"
-    #line 910 "smarty_internal_templateparser.y"
-    function yy_r138()
-    {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor . '.' . $this->yystack[$this->yyidx + 0]->minor;
-    }
-    #line 2799 "smarty_internal_templateparser.php"
-    #line 915 "smarty_internal_templateparser.y"
+
+    #line 1006 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r139()
     {
-        $this->_retvalue = '\'' . $this->yystack[$this->yyidx + 0]->minor . '\'';
+        $this->_retvalue = '\'' . substr($this->yystack[ $this->yyidx + 0 ]->minor, 1) . '\'';
     }
-    #line 2804 "smarty_internal_templateparser.php"
-    #line 920 "smarty_internal_templateparser.y"
+
+    #line 1010 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r140()
     {
-        $this->_retvalue = '(' . $this->yystack[$this->yyidx + - 1]->minor . ')';
+        $this->_retvalue = "''";
     }
-    #line 2809 "smarty_internal_templateparser.php"
-    #line 927 "smarty_internal_templateparser.y"
+
+    #line 1015 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r141()
     {
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 1 ]->minor . '.' . $this->yystack[ $this->yyidx + 0 ]->minor;
+    }
+
+    #line 1023 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r143()
+    {
+        $var =
+            trim(substr($this->yystack[ $this->yyidx + 0 ]->minor, $this->lex->ldel_length, - $this->lex->rdel_length),
+                 ' $');
+        $this->_retvalue = $this->compiler->compileVariable('\'' . $var . '\'');
+    }
+
+    #line 1029 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r144()
+    {
+        $this->_retvalue = '(' . $this->yystack[ $this->yyidx + - 1 ]->minor . ')';
+    }
+
+    #line 1036 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r145()
+    {
-        if ($this->yystack[$this->yyidx + - 1]->minor['var'] == '\'smarty\'') {
+        if ($this->yystack[ $this->yyidx + - 1 ]->minor[ 'var' ] == '\'smarty\'') {
-            $this->_retvalue = $this->compiler->compileTag('private_special_variable', array(), $this->yystack[$this->yyidx + - 1]->minor['smarty_internal_index']) . $this->yystack[$this->yyidx + 0]->minor;
+            $this->_retvalue = $this->compiler->compileTag('private_special_variable', array(),
+                                                           $this->yystack[ $this->yyidx +
+                                                           - 1 ]->minor[ 'smarty_internal_index' ]) .
+                $this->yystack[ $this->yyidx + 0 ]->minor;
         } else {
-            $this->_retvalue = $this->compileVariable($this->yystack[$this->yyidx + - 1]->minor['var']) . $this->yystack[$this->yyidx + - 1]->minor['smarty_internal_index'] . $this->yystack[$this->yyidx + 0]->minor;
+            $this->_retvalue = $this->compiler->compileVariable($this->yystack[ $this->yyidx + - 1 ]->minor[ 'var' ]) .
+                $this->yystack[ $this->yyidx + - 1 ]->minor[ 'smarty_internal_index' ] .
+                $this->yystack[ $this->yyidx + 0 ]->minor;
         }
     }
-    #line 2818 "smarty_internal_templateparser.php"
-    #line 936 "smarty_internal_templateparser.y"
-    function yy_r142()
+
+    #line 1045 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r146()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2823 "smarty_internal_templateparser.php"
-    #line 941 "smarty_internal_templateparser.y"
-    function yy_r143()
+
+    #line 1050 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r147()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2828 "smarty_internal_templateparser.php"
-    #line 946 "smarty_internal_templateparser.y"
-    function yy_r144()
+
+    #line 1055 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r148()
     {
-        if ($this->security && substr($this->yystack[$this->yyidx + - 1]->minor, 0, 1) == '_') {
+        if ($this->security && substr($this->yystack[ $this->yyidx + - 1 ]->minor, 0, 1) == '_') {
             $this->compiler->trigger_template_error(self::Err1);
         }
-        $this->_retvalue = '->' . $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue =
+            '->' . $this->yystack[ $this->yyidx + - 1 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2836 "smarty_internal_templateparser.php"
-    #line 953 "smarty_internal_templateparser.y"
-    function yy_r145()
+
+    #line 1062 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r149()
     {
         if ($this->security) {
             $this->compiler->trigger_template_error(self::Err2);
         }
-        $this->_retvalue = '->{' . $this->compileVariable($this->yystack[$this->yyidx + - 1]->minor) . $this->yystack[$this->yyidx + 0]->minor . '}';
+        $this->_retvalue = '->{' . $this->compiler->compileVariable($this->yystack[ $this->yyidx + - 1 ]->minor) .
+            $this->yystack[ $this->yyidx + 0 ]->minor . '}';
     }
-    #line 2844 "smarty_internal_templateparser.php"
-    #line 960 "smarty_internal_templateparser.y"
-    function yy_r146()
+
+    #line 1069 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r150()
     {
         if ($this->security) {
             $this->compiler->trigger_template_error(self::Err2);
         }
-        $this->_retvalue = '->{' . $this->yystack[$this->yyidx + - 2]->minor . $this->yystack[$this->yyidx + 0]->minor . '}';
+        $this->_retvalue =
+            '->{' . $this->yystack[ $this->yyidx + - 2 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor . '}';
     }
-    #line 2852 "smarty_internal_templateparser.php"
-    #line 967 "smarty_internal_templateparser.y"
-    function yy_r147()
+
+    #line 1076 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r151()
     {
         if ($this->security) {
             $this->compiler->trigger_template_error(self::Err2);
         }
-        $this->_retvalue = '->{\'' . $this->yystack[$this->yyidx + - 4]->minor . '\'.' . $this->yystack[$this->yyidx + - 2]->minor . $this->yystack[$this->yyidx + 0]->minor . '}';
+        $this->_retvalue = '->{\'' . $this->yystack[ $this->yyidx + - 4 ]->minor . '\'.' .
+            $this->yystack[ $this->yyidx + - 2 ]->minor . $this->yystack[ $this->yyidx + 0 ]->minor . '}';
     }
-    #line 2860 "smarty_internal_templateparser.php"
-    #line 975 "smarty_internal_templateparser.y"
-    function yy_r148()
+
+    #line 1084 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r152()
     {
-        $this->_retvalue = '->' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = '->' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 2865 "smarty_internal_templateparser.php"
-    #line 983 "smarty_internal_templateparser.y"
-    function yy_r149()
+
+    #line 1092 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r153()
     {
-        if (!$this->security || $this->smarty->security_policy->isTrustedPhpFunction($this->yystack[$this->yyidx + - 3]->minor, $this->compiler)) {
-            if (strcasecmp($this->yystack[$this->yyidx + - 3]->minor, 'isset') === 0 || strcasecmp($this->yystack[$this->yyidx + - 3]->minor, 'empty') === 0 || strcasecmp($this->yystack[$this->yyidx + - 3]->minor, 'array') === 0 || is_callable($this->yystack[$this->yyidx + - 3]->minor)) {
+        if (!$this->security ||
+            $this->security->isTrustedPhpFunction($this->yystack[ $this->yyidx + - 3 ]->minor, $this->compiler)
+        ) {
+            if (strcasecmp($this->yystack[ $this->yyidx + - 3 ]->minor, 'isset') === 0 ||
+                strcasecmp($this->yystack[ $this->yyidx + - 3 ]->minor, 'empty') === 0 ||
+                strcasecmp($this->yystack[ $this->yyidx + - 3 ]->minor, 'array') === 0 ||
+                is_callable($this->yystack[ $this->yyidx + - 3 ]->minor)
+            ) {
-                $func_name = strtolower($this->yystack[$this->yyidx + - 3]->minor);
+                $func_name = strtolower($this->yystack[ $this->yyidx + - 3 ]->minor);
                 if ($func_name == 'isset') {
-                    if (count($this->yystack[$this->yyidx + - 1]->minor) == 0) {
+                    if (count($this->yystack[ $this->yyidx + - 1 ]->minor) == 0) {
                         $this->compiler->trigger_template_error('Illegal number of paramer in "isset()"');
                     }
-                    $par = implode(',', $this->yystack[$this->yyidx + - 1]->minor);
+                    $par = implode(',', $this->yystack[ $this->yyidx + - 1 ]->minor);
-                    if (strncasecmp($par, '$_smarty_tpl->getConfigVariable', strlen('$_smarty_tpl->getConfigVariable')) === 0) {
+                    if (strncasecmp($par, '$_smarty_tpl->smarty->ext->_config->_getConfigVariable',
+                                    strlen('$_smarty_tpl->smarty->ext->_config->_getConfigVariable')) === 0
+                    ) {
                         self::$prefix_number ++;
-                        $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . '=' . str_replace(')', ', false)', $par) . ';?>';
+                        $this->compiler->prefix_code[] =
+                            '<?php $_tmp' . self::$prefix_number . '=' . str_replace(')', ', false)', $par) . ';?>';
                         $isset_par = '$_tmp' . self::$prefix_number;
                     } else {
                         $isset_par = str_replace("')->value", "',null,true,false)->value", $par);
                     }
-                    $this->_retvalue = $this->yystack[$this->yyidx + - 3]->minor . "(" . $isset_par . ")";
+                    $this->_retvalue = $this->yystack[ $this->yyidx + - 3 ]->minor . "(" . $isset_par . ")";
                 } elseif (in_array($func_name, array('empty', 'reset', 'current', 'end', 'prev', 'next'))) {
-                    if (count($this->yystack[$this->yyidx + - 1]->minor) != 1) {
+                    if (count($this->yystack[ $this->yyidx + - 1 ]->minor) != 1) {
                         $this->compiler->trigger_template_error('Illegal number of paramer in "empty()"');
                     }
                     if ($func_name == 'empty') {
-                        $this->_retvalue = $func_name . '(' . str_replace("')->value", "',null,true,false)->value", $this->yystack[$this->yyidx + - 1]->minor[0]) . ')';
+                        $this->_retvalue = $func_name . '(' . str_replace("')->value", "',null,true,false)->value",
+                                                                          $this->yystack[ $this->yyidx +
+                                                                          - 1 ]->minor[ 0 ]) . ')';
                     } else {
-                        $this->_retvalue = $func_name . '(' . $this->yystack[$this->yyidx + - 1]->minor[0] . ')';
+                        $this->_retvalue = $func_name . '(' . $this->yystack[ $this->yyidx + - 1 ]->minor[ 0 ] . ')';
                     }
                 } else {
-                    $this->_retvalue = $this->yystack[$this->yyidx + - 3]->minor . "(" . implode(',', $this->yystack[$this->yyidx + - 1]->minor) . ")";
+                    $this->_retvalue = $this->yystack[ $this->yyidx + - 3 ]->minor . "(" .
+                        implode(',', $this->yystack[ $this->yyidx + - 1 ]->minor) . ")";
                 }
             } else {
-                $this->compiler->trigger_template_error("unknown function \"" . $this->yystack[$this->yyidx + - 3]->minor . "\"");
+                $this->compiler->trigger_template_error("unknown function \"" .
+                                                        $this->yystack[ $this->yyidx + - 3 ]->minor . "\"");
             }
         }
     }
-    #line 2901 "smarty_internal_templateparser.php"
-    #line 1021 "smarty_internal_templateparser.y"
-    function yy_r150()
+
+    #line 1131 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r154()
     {
-        if ($this->security && substr($this->yystack[$this->yyidx + - 3]->minor, 0, 1) == '_') {
+        if ($this->security && substr($this->yystack[ $this->yyidx + - 3 ]->minor, 0, 1) == '_') {
             $this->compiler->trigger_template_error(self::Err1);
         }
-        $this->_retvalue = $this->yystack[$this->yyidx + - 3]->minor . "(" . implode(',', $this->yystack[$this->yyidx + - 1]->minor) . ")";
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 3 ]->minor . "(" .
+            implode(',', $this->yystack[ $this->yyidx + - 1 ]->minor) . ")";
     }
-    #line 2909 "smarty_internal_templateparser.php"
-    #line 1028 "smarty_internal_templateparser.y"
-    function yy_r151()
+
+    #line 1138 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r155()
     {
         if ($this->security) {
             $this->compiler->trigger_template_error(self::Err2);
         }
         self::$prefix_number ++;
-        $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . '=' . $this->compileVariable("'" . $this->yystack[$this->yyidx + - 3]->minor . "'") . ';?>';
-        $this->_retvalue = '$_tmp' . self::$prefix_number . '(' . implode(',', $this->yystack[$this->yyidx + - 1]->minor) . ')';
+        $this->compiler->prefix_code[] = '<?php $_tmp' . self::$prefix_number . '=' .
+            $this->compiler->compileVariable('\'' . substr($this->yystack[ $this->yyidx + - 3 ]->minor, 1) . '\'') .
+            ';?>';
+        $this->_retvalue =
+            '$_tmp' . self::$prefix_number . '(' . implode(',', $this->yystack[ $this->yyidx + - 1 ]->minor) . ')';
     }
-    #line 2919 "smarty_internal_templateparser.php"
-    #line 1039 "smarty_internal_templateparser.y"
-    function yy_r152()
+
+    #line 1149 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r156()
     {
-        $this->_retvalue = array_merge($this->yystack[$this->yyidx + - 2]->minor, array($this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue =
+            array_merge($this->yystack[ $this->yyidx + - 2 ]->minor, array($this->yystack[ $this->yyidx + 0 ]->minor));
     }
-    #line 2924 "smarty_internal_templateparser.php"
-    #line 1056 "smarty_internal_templateparser.y"
-    function yy_r155()
+
+    #line 1166 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r159()
     {
-        $this->_retvalue = array_merge($this->yystack[$this->yyidx + - 2]->minor, array(array_merge($this->yystack[$this->yyidx + - 1]->minor, $this->yystack[$this->yyidx + 0]->minor)));
+        $this->_retvalue = array_merge($this->yystack[ $this->yyidx + - 2 ]->minor,
+                                       array(array_merge($this->yystack[ $this->yyidx + - 1 ]->minor,
+                                                         $this->yystack[ $this->yyidx + 0 ]->minor)));
     }
-    #line 2929 "smarty_internal_templateparser.php"
-    #line 1060 "smarty_internal_templateparser.y"
-    function yy_r156()
+
+    #line 1170 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r160()
     {
-        $this->_retvalue = array(array_merge($this->yystack[$this->yyidx + - 1]->minor, $this->yystack[$this->yyidx + 0]->minor));
+        $this->_retvalue =
+            array(array_merge($this->yystack[ $this->yyidx + - 1 ]->minor, $this->yystack[ $this->yyidx + 0 ]->minor));
     }
-    #line 2934 "smarty_internal_templateparser.php"
-    #line 1068 "smarty_internal_templateparser.y"
-    function yy_r158()
+
+    #line 1178 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r162()
     {
-        $this->_retvalue = array($this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue = array($this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2939 "smarty_internal_templateparser.php"
-    #line 1076 "smarty_internal_templateparser.y"
-    function yy_r159()
+
+    #line 1186 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r163()
     {
-        $this->_retvalue = array_merge($this->yystack[$this->yyidx + - 1]->minor, $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue =
+            array_merge($this->yystack[ $this->yyidx + - 1 ]->minor, $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 2944 "smarty_internal_templateparser.php"
-    #line 1110 "smarty_internal_templateparser.y"
-    function yy_r166()
-    {
-        $this->_retvalue = '$' . $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
-    }
-    #line 2949 "smarty_internal_templateparser.php"
-    #line 1115 "smarty_internal_templateparser.y"
+
+    #line 1205 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r167()
     {
-        $this->_retvalue = '$' . $this->yystack[$this->yyidx + - 2]->minor . $this->yystack[$this->yyidx + - 1]->minor . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = array($this->yystack[ $this->yyidx + 0 ]->minor, '', 'method');
     }
-    #line 2954 "smarty_internal_templateparser.php"
-    #line 1121 "smarty_internal_templateparser.y"
+
+    #line 1210 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r168()
     {
-        $this->_retvalue = '==';
+        $this->_retvalue =
+            array($this->yystack[ $this->yyidx + - 1 ]->minor, $this->yystack[ $this->yyidx + 0 ]->minor, 'method');
     }
-    #line 2959 "smarty_internal_templateparser.php"
-    #line 1125 "smarty_internal_templateparser.y"
+
+    #line 1215 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r169()
     {
-        $this->_retvalue = '!=';
+        $this->_retvalue = array($this->yystack[ $this->yyidx + 0 ]->minor, '');
     }
-    #line 2964 "smarty_internal_templateparser.php"
-    #line 1129 "smarty_internal_templateparser.y"
+
+    #line 1220 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r170()
     {
-        $this->_retvalue = '>';
+        $this->_retvalue =
+            array($this->yystack[ $this->yyidx + - 1 ]->minor, $this->yystack[ $this->yyidx + 0 ]->minor, 'property');
     }
-    #line 2969 "smarty_internal_templateparser.php"
-    #line 1133 "smarty_internal_templateparser.y"
+
+    #line 1225 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r171()
     {
-        $this->_retvalue = '<';
+        $this->_retvalue = array($this->yystack[ $this->yyidx + - 2 ]->minor,
+                                 $this->yystack[ $this->yyidx + - 1 ]->minor .
+                                 $this->yystack[ $this->yyidx + 0 ]->minor, 'property');
     }
-    #line 2974 "smarty_internal_templateparser.php"
-    #line 1137 "smarty_internal_templateparser.y"
+
+    #line 1231 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r172()
     {
-        $this->_retvalue = '>=';
+        $this->_retvalue[ 'op' ] = ' ' . trim($this->yystack[ $this->yyidx + 0 ]->minor) . ' ';
     }
-    #line 2979 "smarty_internal_templateparser.php"
-    #line 1141 "smarty_internal_templateparser.y"
+
+    #line 1235 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r173()
     {
-        $this->_retvalue = '<=';
+        static $lops = array('eq'          => array('op' => ' == ', 'pre' => null),
+                             'ne'          => array('op' => ' != ', 'pre' => null),
+                             'neq'         => array('op' => ' != ', 'pre' => null),
+                             'gt'          => array('op' => ' > ', 'pre' => null),
+                             'ge'          => array('op' => ' >= ', 'pre' => null),
+                             'gte'         => array('op' => ' >= ', 'pre' => null),
+                             'lt'          => array('op' => ' < ', 'pre' => null),
+                             'le'          => array('op' => ' <= ', 'pre' => null),
+                             'lte'         => array('op' => ' <= ', 'pre' => null),
+                             'mod'         => array('op' => ' % ', 'pre' => null),
+                             'and'         => array('op' => ' && ', 'pre' => null),
+                             'or'          => array('op' => ' || ', 'pre' => null),
+                             'xor'         => array('op' => ' xor ', 'pre' => null),
+                             'isdivby'     => array('op' => ' % ', 'pre' => '!('),
+                             'isnotdivby'  => array('op' => ' % ', 'pre' => '('),
+                             'isevenby'    => array('op' => ' / ', 'pre' => '!(1 & '),
+                             'isnotevenby' => array('op' => ' / ', 'pre' => '(1 & '),
+                             'isoddby'     => array('op' => ' / ', 'pre' => '(1 & '),
+                             'isnotoddby'  => array('op' => ' / ', 'pre' => '!(1 & '),);
+        $op = strtolower(preg_replace('/\s*/', '', $this->yystack[ $this->yyidx + 0 ]->minor));
+        $this->_retvalue = $lops[ $op ];
     }
-    #line 2984 "smarty_internal_templateparser.php"
-    #line 1145 "smarty_internal_templateparser.y"
+
+    #line 1261 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r174()
     {
-        $this->_retvalue = '===';
+        static $scond =
+            array('iseven' => '!(1 & ', 'isnoteven' => '(1 & ', 'isodd' => '(1 & ', 'isnotodd' => '!(1 & ',);
+        $op = strtolower(str_replace(' ', '', $this->yystack[ $this->yyidx + 0 ]->minor));
+        $this->_retvalue = $scond[ $op ];
     }
-    #line 2989 "smarty_internal_templateparser.php"
-    #line 1149 "smarty_internal_templateparser.y"
+
+    #line 1275 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r175()
     {
-        $this->_retvalue = '!==';
+        $this->_retvalue = 'array(' . $this->yystack[ $this->yyidx + - 1 ]->minor . ')';
     }
-    #line 2994 "smarty_internal_templateparser.php"
-    #line 1153 "smarty_internal_templateparser.y"
-    function yy_r176()
-    {
-        $this->_retvalue = '%';
-    }
-    #line 2999 "smarty_internal_templateparser.php"
-    #line 1157 "smarty_internal_templateparser.y"
+
+    #line 1283 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r177()
     {
-        $this->_retvalue = '&&';
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 2 ]->minor . ',' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 3004 "smarty_internal_templateparser.php"
-    #line 1161 "smarty_internal_templateparser.y"
-    function yy_r178()
-    {
-        $this->_retvalue = '||';
-    }
-    #line 3009 "smarty_internal_templateparser.php"
-    #line 1165 "smarty_internal_templateparser.y"
+
+    #line 1291 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r179()
     {
-        $this->_retvalue = ' XOR ';
+        $this->_retvalue =
+            $this->yystack[ $this->yyidx + - 2 ]->minor . '=>' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 3014 "smarty_internal_templateparser.php"
-    #line 1172 "smarty_internal_templateparser.y"
+
+    #line 1295 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r180()
     {
-        $this->_retvalue = 'array(' . $this->yystack[$this->yyidx + - 1]->minor . ')';
+        $this->_retvalue =
+            '\'' . $this->yystack[ $this->yyidx + - 2 ]->minor . '\'=>' . $this->yystack[ $this->yyidx + 0 ]->minor;
     }
-    #line 3019 "smarty_internal_templateparser.php"
-    #line 1180 "smarty_internal_templateparser.y"
-    function yy_r182()
+
+    #line 1311 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r183()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . ',' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor->to_smarty_php($this);
     }
-    #line 3024 "smarty_internal_templateparser.php"
-    #line 1188 "smarty_internal_templateparser.y"
+
+    #line 1316 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r184()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 2]->minor . '=>' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->yystack[ $this->yyidx + - 1 ]->minor->append_subtree($this, $this->yystack[ $this->yyidx + 0 ]->minor);
+        $this->_retvalue = $this->yystack[ $this->yyidx + - 1 ]->minor;
     }
-    #line 3029 "smarty_internal_templateparser.php"
-    #line 1192 "smarty_internal_templateparser.y"
+
+    #line 1321 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r185()
     {
-        $this->_retvalue = '\'' . $this->yystack[$this->yyidx + - 2]->minor . '\'=>' . $this->yystack[$this->yyidx + 0]->minor;
+        $this->_retvalue = new Smarty_Internal_ParseTree_Dq($this, $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 3034 "smarty_internal_templateparser.php"
-    #line 1204 "smarty_internal_templateparser.y"
-    function yy_r187()
+
+    #line 1325 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r186()
     {
-        $this->_retvalue = "''";
+        $this->_retvalue = new Smarty_Internal_ParseTree_Code('(string)' . $this->yystack[ $this->yyidx + - 1 ]->minor);
     }
-    #line 3039 "smarty_internal_templateparser.php"
-    #line 1208 "smarty_internal_templateparser.y"
+
+    #line 1333 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r188()
     {
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor->to_smarty_php();
+        $this->_retvalue = new Smarty_Internal_ParseTree_Code('(string)$_smarty_tpl->tpl_vars[\'' .
+                                                              substr($this->yystack[ $this->yyidx + 0 ]->minor, 1) .
+                                                              '\']->value');
     }
-    #line 3044 "smarty_internal_templateparser.php"
-    #line 1213 "smarty_internal_templateparser.y"
-    function yy_r189()
-    {
-        $this->yystack[$this->yyidx + - 1]->minor->append_subtree($this->yystack[$this->yyidx + 0]->minor);
-        $this->_retvalue = $this->yystack[$this->yyidx + - 1]->minor;
-    }
-    #line 3050 "smarty_internal_templateparser.php"
-    #line 1218 "smarty_internal_templateparser.y"
+
+    #line 1341 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r190()
     {
-        $this->_retvalue = new _smarty_doublequoted($this, $this->yystack[$this->yyidx + 0]->minor);
+        $this->_retvalue =
+            new Smarty_Internal_ParseTree_Code('(string)(' . $this->yystack[ $this->yyidx + - 1 ]->minor . ')');
     }
-    #line 3055 "smarty_internal_templateparser.php"
-    #line 1222 "smarty_internal_templateparser.y"
+
+    #line 1345 "../smarty/lexer/smarty_internal_templateparser.y"
     function yy_r191()
     {
-        $this->_retvalue = new _smarty_code($this, '(string)' . $this->yystack[$this->yyidx + - 1]->minor);
+        $this->_retvalue = new Smarty_Internal_ParseTree_Tag($this, $this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 3060 "smarty_internal_templateparser.php"
-    #line 1230 "smarty_internal_templateparser.y"
-    function yy_r193()
+
+    #line 1349 "../smarty/lexer/smarty_internal_templateparser.y"
+    function yy_r192()
     {
-        $this->_retvalue = new _smarty_code($this, '(string)$_smarty_tpl->tpl_vars[\'' . substr($this->yystack[$this->yyidx + 0]->minor, 1) . '\']->value');
+        $this->_retvalue = new Smarty_Internal_ParseTree_DqContent($this->yystack[ $this->yyidx + 0 ]->minor);
     }
-    #line 3065 "smarty_internal_templateparser.php"
-    #line 1238 "smarty_internal_templateparser.y"
-    function yy_r195()
-    {
-        $this->_retvalue = new _smarty_code($this, '(string)(' . $this->yystack[$this->yyidx + - 1]->minor . ')');
-    }
-    #line 3070 "smarty_internal_templateparser.php"
-    #line 1242 "smarty_internal_templateparser.y"
-    function yy_r196()
-    {
-        $this->_retvalue = new _smarty_tag($this, $this->yystack[$this->yyidx + - 1]->minor);
-    }
-    #line 3075 "smarty_internal_templateparser.php"
-    #line 1246 "smarty_internal_templateparser.y"
-    function yy_r197()
-    {
-        $this->_retvalue = new _smarty_dq_content($this, $this->yystack[$this->yyidx + 0]->minor);
-    }
 
-    #line 3080 "smarty_internal_templateparser.php"
-
     private $_retvalue;
 
     public function yy_reduce($yyruleno)
     {
-        $yymsp = $this->yystack[$this->yyidx];
-        if ($this->yyTraceFILE && $yyruleno >= 0
-            && $yyruleno < count(self::$yyRuleName)
-        ) {
-            fprintf($this->yyTraceFILE, "%sReduce (%d) [%s].\n",
-                    $this->yyTracePrompt, $yyruleno,
+        if ($this->yyTraceFILE && $yyruleno >= 0 && $yyruleno < count(self::$yyRuleName)) {
+            fprintf($this->yyTraceFILE, "%sReduce (%d) [%s].\n", $this->yyTracePrompt, $yyruleno,
-                    self::$yyRuleName[$yyruleno]);
+                    self::$yyRuleName[ $yyruleno ]);
         }
 
         $this->_retvalue = $yy_lefthand_side = null;
-        if (array_key_exists($yyruleno, self::$yyReduceMap)) {
+        if (isset(self::$yyReduceMap[ $yyruleno ])) {
             // call the action
             $this->_retvalue = null;
-            $this->{'yy_r' . self::$yyReduceMap[$yyruleno]}();
+            $this->{'yy_r' . self::$yyReduceMap[ $yyruleno ]}();
             $yy_lefthand_side = $this->_retvalue;
         }
-        $yygoto = self::$yyRuleInfo[$yyruleno]['lhs'];
-        $yysize = self::$yyRuleInfo[$yyruleno]['rhs'];
+        $yygoto = self::$yyRuleInfo[ $yyruleno ][ 0 ];
+        $yysize = self::$yyRuleInfo[ $yyruleno ][ 1 ];
         $this->yyidx -= $yysize;
         for ($i = $yysize; $i; $i --) {
             // pop all of the right-hand side parameters
             array_pop($this->yystack);
         }
-        $yyact = $this->yy_find_reduce_action($this->yystack[$this->yyidx]->stateno, $yygoto);
+        $yyact = $this->yy_find_reduce_action($this->yystack[ $this->yyidx ]->stateno, $yygoto);
         if ($yyact < self::YYNSTATE) {
             if (!$this->yyTraceFILE && $yysize) {
                 $this->yyidx ++;
